unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, NsRequest, ClientDelphi, nsClassIntf, NSBase,
  NsRequestBase, Grids, DBGrids, DB, XPMan, NsMemTbl, NsMemDS, ClientDS,
  ComCtrls;

type
  TForm1 = class(TForm)
    Request1: TRequest;
    ClientDelphi1: TClientDelphi;
    BitBtn1: TBitBtn;
    pg: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    QueryMan1: TQueryMan;
    Memo2: TMemo;
    XPManifest1: TXPManifest;
    Button1: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Request1ReceiveMsg(Sender: TObject; aThread: TThread; aSender:
        string; aCounter: Integer; aCmd: string; const aClientData, aServerData:
        Variant);
    procedure Request1ReceiveServerMsg(Sender: TObject; aThread: TThread; aCommand:
        string; const aData: Variant);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  pg.TabIndex := 0;
  pg.Enabled := false;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  try
  Request1.Open;
  ShowMessage('Connected');
  pg.Enabled := true;
  except
    ShowMessage('Failed to connect');
  end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Request1.SendMsgToServerNoResult('hello', 'Ŭ̾Ʈ ϴ.');
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
begin
  Request1.SendMsgToClient('hello',' ö');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if not Request1.AcquireSession then begin
    ShowMessage('Can not get database session from pool');
    exit;
  end;
  try
  QueryMan1.SQL.Text := Memo2.Lines.Text;
  QueryMan1.Reopen;
  finally
    Request1.ReleaseSession;
  end;
end;

procedure TForm1.Request1ReceiveMsg(Sender: TObject; aThread: TThread; aSender:
    string; aCounter: Integer; aCmd: string; const aClientData, aServerData:
    Variant);
begin
  Memo1.Lines.Add(aSender +  ' ' + acmd + ' ' + vartostr(aClientData));
end;

procedure TForm1.Request1ReceiveServerMsg(Sender: TObject; aThread: TThread;
    aCommand: string; const aData: Variant);
begin
  Memo1.Lines.Add('Server>> ' + acommand + ' ' + vartostr(adata));
end;

end.
